/*----------------------------------------------------------------------------
/ ėpR}h̓[`								2005 (C)LogicPack
/	2005.01										000		M.Yamada
/		first release(use M-801)
/	2005.05.19									001		M.Yamada
/		EOR}hݒł悤ɕύX
/		EESCV[PXT|[g(Windows2000 + TeraTerm)
/		/	: R}h͗I
/		/	: J[\ړ
/		DEL		: 폜
/		INS		: ̓[hؑ
/	2005.07.27									002		M.Yamada
/		EM-802pJX^
/		E񏈗mstring.cɕ
/		Ecmd_prompt()ǉ
/---------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "lp.h"
#include "sci.h"
#include "command.h"
#include "cmddef.h"
#include "debug.h"
#include "mstring.h"											/*ADD 002*/

#if defined(M802)												/*ADD 002*/
#include "m802.h"
#include "usbn9604.h"
int usb_get(void);
#endif

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
#define COMMAND_LINE_SIZE	(COMMAND_LINE_MAX + 1)
#define COMMAND_STR_SIZE	(COMMAND_STR_MAX + 1)
#define PARAM_STR_SIZE		(PARAM_STR_MAX + 1)

/* R}he[u */
typedef struct{
	char cmd[COMMAND_STR_SIZE];			/* R}h */
	int cs;								/* r */
	bool (*func)(const PARAM_INFO*);	/* s֐ */
}COMMAND_TABLE;

#define ESC_OUT		-1
#define ESC_IN		0
/* ESCV[PX */
enum{
	KEY_UP = 1, KEY_DOWN, KEY_RIGHT, KEY_LEFT,
	KEY_INS, KEY_DEL, KEY_HOME, KEY_END, KEY_PUP, KEY_PDOWN,
	KEY_F1, KEY_F2, KEY_F3, KEY_F4, KEY_F5, KEY_F6,
	KEY_F7, KEY_F8, KEY_F9, KEY_F10, KEY_F11, KEY_F12,
};

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
/* message string */
//static const char prompt[] = COMMAND_PROMPT;						//MOD 002
static const char *prompt;

static const char delim[] = "\r\n";

static const char command_error_str[] = "command error";

static int entry_count;
static COMMAND_TABLE cmd_tbl[COMMAND_ENTRY_MAX+1];

/* prototype */
static int con_job(word *data, PARAM_INFO *param);
static int analize(const char *str, PARAM_INFO *param);
static int esc_code(byte data);

/* R}hCobt@Ǘ */
static int buf_init(void);
static char *buf_getbuf(void);
static int buf_set(void);
static void buf_cdec(void);
static void buf_cinc(void);
static int buf_del(void);
static int buf_bs(void);
static int buf_add(byte bdt, bool insert);

/* R\[o͊֘A */
static void redrawc(const char *str, char *cursor);
static void redraw(const char *str, char *cursor);

/* historyǗ */
static void hist_entry(const char *str);
static bool hist_dec(char *str);
static bool hist_inc(char *str);
static void hist_selclear(void);

/*-------------------------------------------------------------------
/ R}hvvgݒ
/	ENT:
/	  char *str							vvg
/------------------------------------------------------------------*/
void cmd_prompt(const char *str)
{
	prompt = str;
}

/*-------------------------------------------------------------------
/ R}ho^
/	ENT:
/	  char *str							R}h
/	  int cs							r
/	  bool func(const PARAM*)			֐
/	RET:
/	  bool								FALSE : o^s
/										TRUE : o^
/	ATN:
/	  Ecs0w肵ꍇSrɂȂ
/	  ER}h𕡐o^鎞csooɂ
/		ꍇ͓o^Ԃɒӂ
/		(R}h͓o^ɍs)
/------------------------------------------------------------------*/
bool cmd_entry(const char *str, int cs, bool func(const PARAM_INFO*))
{
	if( entry_count >= COMMAND_ENTRY_MAX ){ return FALSE; }

	strcpy(cmd_tbl[entry_count].cmd, str);	/* R}hL^ */
	cmd_tbl[entry_count].cs = cs;			/* rL^ */
	cmd_tbl[entry_count].func = func;		/* o^ */

	++entry_count;
	strcpy(cmd_tbl[entry_count].cmd, "");
	cmd_tbl[entry_count].func = NULL;

	return TRUE;
}

/*-------------------------------------------------------------------
/ R}h͂Ǝs
/	RET:
/	  int								R}ho^ԍ
/------------------------------------------------------------------*/
int cmd_job(void)
{
	static PARAM_INFO param;
	int cnum;
	word data;

	if( (cnum = con_job(&data, &param)) != -1 ){	/* R\[ */
		bool cmd_end;
		cmd_end = cmd_tbl[cnum].func(&param);		/* R}hs */
		if( cmd_end ){
			con_out(prompt);
		}
	}
	return cnum;
}

/*--------------------------------------------------------------
/ Console
/	ENT:
/	  word *data					Mf[^|C^
/	RET:
/	  int							!-1:R}hԍ
/-------------------------------------------------------------*/
static int con_get(void)										/*ADD 002*/
{
	int data;
	if( (data = sci1_get()) & 0x100 ){ return data; }
#if defined(M802)
//	if( usb_mode == USB_P1 || usb_mode == USB_P2 ){
	if( usb_mode == USB_P2 ){
		data = usb_get();
	}
#endif
	return data;
}

static int con_job(word *data, PARAM_INFO *param)
{
#if 0
	const char *key_name[] = {
		"",
		"KEY_UP", "KEY_DOWN", "KEY_RIGHT", "KEY_LEFT",
		"KEY_INS", "KEY_DEL", "KEY_HOME", "KEY_END", "KEY_PUP", "KEY_PDOWN",
		"KEY_F1", "KEY_F2", "KEY_F3", "KEY_F4", "KEY_F5", "KEY_F6",
		"KEY_F7", "KEY_F8", "KEY_F9", "KEY_F10", "KEY_F11", "KEY_F12"
	};
#endif
	static bool first = TRUE;
	static int count;				/*  */
	static bool esc_in;				/* ESC code */
	static bool insert;				/* INSERTtO */
	int cmdnum = -1;

	if( first ){
		first = FALSE;
		*buf_getbuf() = '\0';
		count = buf_set();
		esc_in = FALSE;
		insert = TRUE;
	}
	while( ((*data = con_get()) & 0x100) ){						/*MOD 002*/
		byte bdt;
		bdt = (byte)(*data);
		if( bdt == 0x1b ){						/* ESC */
			if( esc_in ){
				esc_in = FALSE;
			}else{
				esc_in = TRUE;
			}
		}else if( esc_in ){
			int key;
			if( (key = esc_code(bdt)) > 0 ){
				switch( key ){
					case KEY_UP:
					case KEY_DOWN:
					{
						bool exist;
						exist = (key == KEY_UP) ?
									hist_dec(buf_getbuf()) :
									hist_inc(buf_getbuf()) ;
						if( exist ){
							count = buf_set();
							insert = TRUE;
						}
						break;
					}
					case KEY_LEFT:	buf_cdec();						break;
					case KEY_RIGHT:	buf_cinc();						break;
					case KEY_INS:	insert = insert ? FALSE : TRUE;	break;
					case KEY_DEL:	count = buf_del();				break;
				}
				esc_in = FALSE;
			}else{
				esc_in = (key == ESC_IN) ? TRUE : FALSE;
			}
		}else if( bdt == '\r' ){
			con_out(delim);									/* echo back */
#if defined(_M802)												/*ADD 002*/
			if( usb_mode == USB_P1 ){
				UsbPut(1, (byte*)delim, 2);
			}
#endif
			if( count > 0 ){ hist_entry(buf_getbuf()); }	/* ǉ */
			hist_selclear();								/* INA */

			cmdnum = analize(buf_getbuf(), param);			/* ͉ */
			count = buf_init();								/* obt@NA */
			if( cmdnum == -1 ){
				 con_out(prompt);
			}
			insert = TRUE;
			break;
		}else if( bdt == '\n' ){
			/* Ȃ */
		}else if( bdt == '\b' ){					/* BS */
			count = buf_bs();
		}else if( isprint(bdt) ){
			if( count < COMMAND_LINE_MAX ){
				sci1_put(bdt);	sci1_txtrg();		/* echo back */
#if defined(_M802)
				if( usb_mode == USB_P1 ){
					UsbPut(1, &bdt, 1);
				}
#endif
				count = buf_add(bdt, insert);
			}
		}
	}
	return cmdnum;
}

/*---------------------------------------------------------
/ R}hCobt@ǗƃR\[o
/--------------------------------------------------------*/
static char buf_buf[COMMAND_LINE_SIZE];
static char *buf_cp;					/* J[\ʒu */
static char *buf_ep;					/* I[ʒu */
static int buf_cnt;						/*  */

/*  */
static int buf_init(void)
{
	buf_cp = buf_ep = buf_buf;
	*buf_ep = '\0';
	buf_cnt = 0;
	return buf_cnt;
}

/* obt@ւ̃|C^擾 */
static char *buf_getbuf(void)
{
	return buf_buf;
}

/* VKZbgyяo */
static int buf_set(void)
{
	buf_cnt = (int)strlen(buf_buf);
	buf_cp = buf_ep = &buf_buf[buf_cnt];
	*buf_ep = '\0';
	redraw(buf_buf, NULL);
	return buf_cnt;
}
/* J[\ړ */
static void buf_cdec(void)
{
	if( buf_cp > buf_buf ){ redrawc(buf_buf, --buf_cp); }
}
/* J[\Eړ */
static void buf_cinc(void)
{
	if( buf_cp < buf_ep ){ redrawc(buf_buf, ++buf_cp); }
}
/* Delite */
static int buf_del(void)
{
	if( (buf_ep > buf_buf) && (buf_cp != buf_ep) ){
		char *p;
		/* Oɂ炷 */
		for( p = buf_cp; p != buf_ep; p++ ){
			*p = *(p + 1);
		}
		buf_cnt--;
		buf_ep--;
		*buf_ep = '\0';
		if( buf_cp != buf_ep ){
			redraw(buf_buf, buf_cp);
		}else{
			redraw(buf_buf, NULL);
		}
	}
	return buf_cnt;
}
/* Back Space */
static int buf_bs(void)
{
	if( buf_cp > buf_buf ){
		char *p;
		/* Oɂ炷 */
		for( p = buf_cp; p != buf_ep; p++ ){
			*p = *(p + 1);
		}
		buf_cnt--;
		buf_cp--;
		buf_ep--;
		*buf_ep = '\0';
		if( buf_cp != buf_ep ){
			redraw(buf_buf, buf_cp);
		}else{
			redraw(buf_buf, NULL);
		}
	}
	return buf_cnt;
}

/* ǉ */
static int buf_add(byte bdt, bool insert)
{
	if( buf_cp != buf_ep ){
		if( insert ){			/* INSERT(ʏ탂[h) */
			int i;
			char *p;
			for( p = buf_ep; p >= buf_cp; p-- ){
				*(p + 1) = *p;
			}
			*buf_cp = bdt;
			buf_cp++;
			buf_ep++;
			*buf_ep = '\0';
			buf_cnt++;
		}else{
			*buf_cp++ = bdt;
		}
		redraw(buf_buf, buf_cp);
	}else{
		*buf_cp++ = bdt;
		*++buf_ep = '\0';
		buf_cnt++;
	}
	return buf_cnt;
}

/*---------------------------------------------------------
/ J[\܂ł̏o
/--------------------------------------------------------*/
static void redrawc(const char *str, char *cursor)
{
	byte dt;
	dt = *cursor;		/* save */
	*cursor = '\0';
	con_out("\r");
	con_out(prompt);
	con_out(str);
	*cursor = dt;		/* load */
}
/*---------------------------------------------------------
/ ďo
/--------------------------------------------------------*/
static void redraw(const char *str, char *cursor)
{
	/* sS̏o */
	con_out("\r");
	con_clear((int)strlen(prompt) + COMMAND_LINE_MAX);
	con_out("\r");
	con_out(prompt);
	con_out(str);
	/* J[\ʒu-1܂łďo */
	if( cursor != NULL ){
		redrawc(str, cursor);
	}
}

/*---------------------------------------------------------
/ R}hC
/	DOC:
/	  擪1ŃR}h
/--------------------------------------------------------*/
static int analize(const char *str, PARAM_INFO *param)
{
	static char cmd[COMMAND_STR_SIZE];
	static char pstr[PARAM_MAX][PARAM_STR_SIZE];
	COMMAND_TABLE *cp;
	int pcnt = 0;					/* p[^ */
	int num;
	int i;
	char *p;

	str = extract_str(str, cmd, COMMAND_STR_MAX);	/* command */
	str = skip_space(str);

	for( i = 0; i < PARAM_MAX; i++ ){
		str = extract_str(str, pstr[i], PARAM_STR_MAX);
		str = skip_space(str);
		if( pstr[i][0] != '\0' ){ pcnt++; }
	}
	/* search */
	cp = &cmd_tbl[0];
	num = 0;
	/* 啶ϊ */
	for(p = cmd; *p != '\0'; p++){
		*p = toupper(*p);
	}
	while( cp->func != NULL ){
		if( cp->cs == 0 ){				/* Sv */
			if( strcmp(cmd, cp->cmd) == 0 ){ break; }
		}else{
			if( strncmp(cmd, cp->cmd, cp->cs) == 0 ){ break; }
		}
		cp++;
		num++;
	}
#if 0
	debug_out(cmd);
	debug_out("\r\n");
	for( i = 0; i < pcnt; i++ ){
		debug_out(pstr[i]);
		debug_out("\r\n");
	}
#endif
	if( cmd[0] == '\0' ){
		return -1;
	}else if(cp->func == NULL){					/* `R}h */
		con_out(command_error_str);
		con_out(delim);
		con_out(delim);
		return -1;
	}
	for( i = 0; i < PARAM_MAX; i++ ){
		param->p[i] = pstr[i];
	}
	param->count = pcnt;
	return num;
}

/*-----------------------------------------------
/ ESC CODE
/	RET:
/	  int 						-1:ESC OUT
/								0:ESC INNER
/								0<:KEY_CODE
/----------------------------------------------*/
typedef struct{
	char *str;
	int len;
	int code;
}ETABLE;

static const ETABLE ecode[] = {
	{ "[A",		2,	KEY_UP		},	/*  */
	{ "[B",		2,	KEY_DOWN	},	/*  */
	{ "[C",		2,	KEY_RIGHT	},	/*  */
	{ "[D",		2,	KEY_LEFT	},	/*  */
	{ "[1~",	3,	KEY_INS		},	/* INS */
	{ "[11~",	4,	KEY_F1,		},	/* F1 */
	{ "[12~",	4,	KEY_F2,		},	/* F2 */
	{ "[13~",	4,	KEY_F3,		},	/* F3 */
	{ "[14~",	4,	KEY_F4,		},	/* F4 */
	{ "[15~",	4,	KEY_F5,		},	/* F5 */
	{ "[17~",	4,	KEY_F6,		},	/* F6 */
	{ "[18~",	4,	KEY_F7,		},	/* F7 */
	{ "[19~",	4,	KEY_F8,		},	/* F8 */
	{ "[2~",	3,	KEY_HOME	},	/* HOME */
	{ "[20~",	4,	KEY_F9,		},	/* F9 */
	{ "[21~",	4,	KEY_F10,	},	/* F10 */
	{ "[23~",	4,	KEY_F11,	},	/* F11 */
	{ "[24~",	4,	KEY_F12,	},	/* F12 */
	{ "[3~",	3,	KEY_PUP		},	/* PUP */
	{ "[4~",	3,	KEY_DEL		},	/* DEL */
	{ "[5~",	3,	KEY_END		},	/* END */
	{ "[6~",	3,	KEY_PDOWN	},	/* PDOWN */
	{ NULL,		0,	0			},
};

static int esc_code(byte data)
{
	static const ETABLE *p;
	static bool first = TRUE;
	static int count;
	bool esc_in = TRUE;
	int i;
	int result = ESC_IN;

	if( first ){
		first = FALSE;
		count = 0;
		p = &ecode[0];
	}
	if( count == 0 ){
		if( data == '[' ){
			count++;
		}else{
			first = TRUE;
			result = ESC_OUT;
		}
	}else{
		for(; p->str != NULL; p++ ){
			if( count < p->len ){
				if( data == p->str[count] ){
					break;
				}
			}
		}
		++count;
		if( p->str != NULL ){			/* v */
			if( (count == p->len) && (p->str[count] == '\0') ){
				result = p->code;
				first = TRUE;
			}
		}else{							/* Y */
			first = TRUE;
			result = ESC_OUT;
		}
	}
	return result;
}

/*---------------------------------------------------------
/ HISTORYǗ
/--------------------------------------------------------*/
static char hist_buf[HISTORY_MAX][COMMAND_LINE_SIZE];	/* ring buffer */
static int hist_oldi = -1;								/* ŌÃobt@indx */
static int hist_newi = -1;								/* ŐVobt@indx */
static int hist_i = -1;									/* Iindx */

/* o^ */
static void hist_entry(const char *str)
{
	if( ++hist_newi == HISTORY_MAX ){ hist_newi = 0; }	/* inc */
	strcpy(&hist_buf[hist_newi][0], str);
	if( hist_newi == hist_oldi ){
		if( ++hist_oldi == HISTORY_MAX ){ hist_oldi = 0; }
	}
	if( hist_oldi == -1 ){ hist_oldi = 0; }
//	hist_i = -1;									/* 𖢑I */
}

/* Dec */
static bool hist_dec(char *str)
{
	if( hist_newi == -1 ){		return FALSE; }		/* o^ */
	if( hist_i == hist_oldi ){	return FALSE; }		/* ŌÑI */

	if( hist_i == -1 ){
		hist_i = hist_newi;				/* 𖢑I  ŐVI */
	}else{
		if( --hist_i < 0 ){ hist_i = HISTORY_MAX -1; }	/* dec */
	}

	strcpy(str, &hist_buf[hist_i][0]);
	return TRUE;
}

/* Inc */
static bool hist_inc(char *str)
{
	if( hist_newi == -1 ){		return FALSE; }		/* o^ */
	if( hist_i == hist_newi ){	return FALSE; }		/* ŐVI */
	if( hist_i == -1 ){			return FALSE; }		/* 𖢑I */

	if( ++hist_i == HISTORY_MAX ){ hist_i = 0; }		/* inc */

	strcpy(str, &hist_buf[hist_i][0]);
	return TRUE;
}

/* IgIԂɐݒ */
static void hist_selclear(void)
{
	hist_i = -1;
}


/*-----[ ėp ]---------------------------------------------------------*/
/*-------------------------------------------------------------------
/ o
/------------------------------------------------------------------*/
void con_out(const char *str)
{
	int len, slen;
	do{
		len = (int)strlen(str);
		slen = sci1_puts((byte*)str, len);
		str += slen;
		len -= slen;
	}while(len > 0);
}

/*-------------------------------------------------------------------
/ sNA
/------------------------------------------------------------------*/
void con_clear(int len)
{
	while( len > 0 ){
		if( sci1_put(' ') == 0 ){
			len--;
		}
	}
}

/*-------------------------------------------------------------------
/ ̓`FbN
/------------------------------------------------------------------*/
bool kbhit(void)
{
	bool key = FALSE;
	if( sci1_get() & 0x100 ){
		key = TRUE;
		while( sci1_get() & 0x100 ){;}		/* ǂݔ΂ */
	}
	return key;
}
